## mingw-w64-cppwinrt-2.0.240111.5-1.src.tar.zst

=== test/old_tests/CMakeLists.txt ===
add_subdirectory(UnitTests)
